var YDGouwuExt = {
  version: '',
  vendor: '',
  prefs: null,

  init: function() {
    this.prefs = Components.classes["@mozilla.org/preferences-service;1"].
		        getService(Components.interfaces.nsIPrefService);
	this.prefs = this.prefs.getBranch("extensions.youdaogouwu.");

    this.version = this.prefs.getCharPref("currentversion");
    this.vendor = this.prefs.getCharPref("vendor");

    var appcontent = document.getElementById("appcontent"); // browser
    if (appcontent) {
      appcontent.addEventListener("DOMContentLoaded", this.onPageLoad, true);
    }
  },
  
  onPageLoad: function(aEvent) {
	var doc = aEvent.originalTarget;
    var win = doc.defaultView;

    if (win === win.top && urls_reg.test(doc.location.href)) {
      YDGouwuExt.insertOptionNode(doc);
      YDGouwuExt.injectScript(win, doc);
    }
  },

  injectScript: function(win, doc) {
	// insert the script to head
    var daogw_s = doc.createElement('script');
    daogw_s.charset = 'UTF-8';
    daogw_s.type = 'text/javascript';
    daogw_s.id = 'youdao_gouwu_assistant';
    daogw_s.src = 'http://shared.ydstatic.com/gouwuex/ext/script/extension_2_9.js?browser=firefox&version=' + this.version + '&vendor=' + this.vendor;
    doc.getElementsByTagName('head')[0].appendChild(daogw_s);
  },

  insertOptionNode: function(doc) {
    var optionNode = doc.getElementById('youdaoGWZS_options');
    if (!optionNode) {
      var opt;
      if (this.prefs.prefHasUserValue('jsoptions')) {
        opt = new StrOpt(this.prefs.getCharPref('jsoptions'));
      } else {
        opt = new StrOpt("");
      }
      opt['vendor'] = this.vendor;
      opt['version'] = this.version;
      opt['browser'] = "firefox";
      var optionstr = opt.toOptString();

      optionNode = doc.createElement('span');
      optionNode.id = 'youdaoGWZS_options';
      optionNode.innerHTML = optionstr;

      var wr = document.createElement("span");
      wr.id = "youdao_gouwu";
      wr.style.display = 'none';

      var conf = document.createElement("span");
      conf.id = "youdaoGWZS_config";
      conf.innerHTML = encodeURIComponent("{}");
      wr.appendChild(conf);
      wr.appendChild(optionNode);

      doc.getElementsByTagName('body')[0].appendChild(wr);
      // setAttribute()只在元素被插入到DOM树之后生效
      optionNode.setAttribute('prevValue', optionstr);
      setInterval(function() {
        var on = window.content.document.getElementById('youdaoGWZS_options');
        if (on) {
          var now = on.innerHTML;
          var prev = on.getAttribute('prevValue');
          var other = YDGouwuExt.prefs.getCharPref('jsoptions');
          if (now != prev) {
            on.setAttribute('prevValue', now);
            YDGouwuExt.prefs.setCharPref('jsoptions', now);
          } else if (now != other) {
            on.innerHTML = other;
            on.setAttribute('prevValue', other);
          }
        }
      }, 1000);
    }
  },

  togglePopup: function() {
    var anchor = document.getElementById('ydgw-toolbar-button');
    var panel = document.getElementById('ydgw-popup-window');
    if (panel.state != 'closed') {
      panel.hidePopup();
      return;
    }
    panel.openPopup(anchor, 'after_end');
    YDGouwuPopup.sendLog('ACTION', 'CLICK_BUTTON');
  }
};
